<?php

function NullErrorHandler()
{
}

class Server
{
  private $db;
  
  public function __construct($db)
  {
    $this->db = $db;
  }
  
  public function HumanDate($date, $time = 1)
  {
    // input date is 0000-00-00 00:00:00
    $date_arr = explode(' ', $date);
    $date = explode('-', $date_arr[0]);
    $time_stp = explode(':', $date_arr[1]);
    $time = mktime($time_stp[0], $time_stp[1], $time_stp[2], $date[1], $date[2], $date[0]);
    if($time == 1) $human_date = date('d.m.Y H:i:s', $time);
      else $human_date = date('d.m.Y', $time);
    return($human_date);
  }

  public function RealmOnline()
  {
    global $Config;
    
    $this->db->select_db($Config['Mangos']['DatabaseRealmd']);
    $DbResult = $this->db->query('SELECT COUNT(*) FROM `account` WHERE `online` = 1');
    $DbRow = $DbResult->fetch_row();
    return($DbRow[0]);
  }

  public function ParseCopper($copper_in)
  {
    $copper = $copper_in;
    $golds = floor($copper / 10000);
    $num = $copper - $golds * 10000;
    $silver = floor($num / 100);
    $copper = $num - $silver * 100;
    $show_golds = '<font size="4">'.$golds.'</font>&nbsp;<img src="imgs/inc/g.gif">';
    $show_silver = '<font size="4">'.$silver.'</font>&nbsp;<img src="imgs/inc/s.gif">';
    $show_copper = '<font size="4">'.$copper.'</font>&nbsp;<img src="imgs/inc/c.gif">';
    return($show_golds.'&nbsp;'.$show_silver.'&nbsp;'.$show_copper);
  }
      
  public function MangosOnline($RealmId)
  {
    global $Config;
    
    $this->db->select_db($Config['Mangos']['RealmList'][$RealmId]['DatabaseCharacters']);    
    $DbResult = $this->db->query('SELECT COUNT(*) FROM `characters` WHERE `online` = 1');
    $DbRow = $DbResult->fetch_row();
    return($DbRow[0]);
  }

  public function ServerMangosOnline()
  {
    global $Config;
    
    $TotalCount = 0;
    foreach($Config['Mangos']['RealmList'] as $Index => $Realm)
    {
      $TotalCount += $this->MangosOnline($Index);
    }
    return($TotalCount);
  }  

  public function ServerOnline($Address, $Port, $Timeout = 0.5)
  {
    set_error_handler('NullErrorHandler');
    if($Socket = @fsockopen($Address, $Port, $ERROR_NO, $ERROR_STR, (float)$Timeout))
    {
      fclose($Socket);
      $Result = true;
    } else $Result = false;
    restore_error_handler();
    return($Result);  }

  public function ServerImg($status)
  {
    if($status) return('<img src="imgs/inc/on.gif" alt="online" />&nbsp;<span style="text-color: #234303; text-size: 4;">Online</span>');
      else return('<img src="imgs/inc/off.gif" alt="offline" />&nbsp;<span style="text-color: #990000; text-size: 4;">Offline</span>');
  }

  public function ServerUptime()
  {
    global $Config;

    $this->db->select_db($Config['Mangos']['DatabaseRealmd']);
    $row = $this->db->query('SELECT `starttime`, `uptime` FROM `uptime` ORDER BY `starttime` DESC LIMIT 1')
  ->fetch_array();
    $uptime = round($row['uptime'] / 3600);
    return($uptime);
  }

  public function CharacterCount($RealmId)
  {
    global $Config;

    $this->db->select_db($Config['Mangos']['RealmList'][$RealmId]['DatabaseCharacters']);    
    $DbResult = $this->db->query('SELECT COUNT(*) FROM `characters`');
    $DbRow = $DbResult->fetch_row();
    return($DbRow[0]);
  }

  public function ServerCharacterCount()
  {
    global $Config;
    
    $TotalCount = 0;
    foreach($Config['Mangos']['RealmList'] as $Index => $Realm)
    {
      $TotalCount += $this->CharacterCount($Index);
    }
    return($TotalCount);
  }
  
  public function AccountCount()
  {
    global $Config;

    $this->db->select_db($Config['Mangos']['DatabaseRealmd']);
    $row = $this->db->query('SELECT COUNT(*) FROM account')->fetch_row();
    return($row[0]);
  }

  public function GuidToCharName($guid)
  {
    global $Config;

    $this->db->select_db($Config['Mangos']['RealmList'][$_COOKIE['RealmIndex']]['DatabaseCharacters']);
    $row = $this->db->query('SELECT `name` FROM `characters` WHERE `guid` = "'.$guid.'" LIMIT 1')->fetch_array();
    return($row['name']);
  }
  
  public function ShowGmLog($log)
  {
    echo('<table border="1" width="540">'.
      '<tr>
            <th>Čas</th>
            <th>GM</th>
            <th>Příkaz</th>
            <th>Vybrán</th>
          </tr>');
    $gm_log = ereg_replace("\n",";",$log);
    $gm_log = explode(";",$gm_log);
    $gm_log = array_reverse($gm_log);
    foreach($gm_log as $row)
    {
      if (strpos($row,"Command:") == true)
      {
        $edited = str_replace(" Command: ", ";", $row);     // 0 - time
        $edited = str_replace(" (Account: ", ";", $edited); // 1 - command
        $edited = str_replace(" [Player: ", ";", $edited);  // 2 - gm
        $edited = str_replace(" Selected: ", ";", $edited); // 3 - position
        $edited = str_replace(" (GUID: ", ";", $edited);    // 4 - selected
        $edited = str_replace(")]", ";", $edited);          // 5 - selected guid
        $edited_arr = explode(";",$edited);
        if($edited_arr[4] == "player") $sel_name = " - ".$this -> GuidToCharName($edited_arr[5]);
          else $sel_name = '';
        $human_date = $this -> HumanDate ($edited_arr[0]);
        echo('<tr>
            <td><font size="2">'.$human_date.'</font></td>
            <td>'.$edited_arr[2].'</td>
            <td>'.$edited_arr[1].'</td>
            <td>'.$edited_arr[4].$sel_name.'</td>
          </tr>');
      }
      if(strpos($row, 'mail item:') == true)
      {
        $edited = str_replace(" GM ", ";", $row);
        $edited = str_replace(" (Account: ", ";", $edited);
        $edited = str_replace(") mail item: ", ";", $edited);
        $edited = str_replace(" (Account: ", ";", $edited);
        $edited = str_replace(")", "", $edited);
        $edited_arr = explode(";",$edited);
        $human_date = $this -> HumanDate ($edited_arr[0]);
        echo('<tr>
            <td><font size="2">'.$human_date.'</font></td>
            <td>'.$edited_arr[1].'</td>
            <td>Send : '.$edited_arr[3].')</td>
            <td>-</td>
          </tr>');
      }
      if(strpos($row,"trade:") == true)
      {
        $edited = str_replace(" GM ", ";", $row);
        $edited = str_replace(" (Account: ", ";", $edited);
        $edited = str_replace(") trade: ", ";", $edited);
        $edited = str_replace(" (Account: ", ";", $edited);
        $edited = str_replace(")", "", $edited);
        $edited_arr = explode(";",$edited);
            
        $human_date = $this -> HumanDate ($edited_arr[0]);
        echo('<tr>
            <td><font size="2">'.$human_date.'</font></td>
            <td>'.$edited_arr[1].'</td>
            <td>Trade : '.$edited_arr[3].')</td>
            <td>-</td>
          </tr>');
      }
    }
    echo('</table>'); 
  }

  public function SeoUrl($title)
  {  
    $address = $title;  
    $diakritika = array("á","ä","č","ď","é","ě","ë","í","ň","ó","ö","ř","š","ť","ú","ů","ü","ý","ž","Á","Ä","Č","Ď","É","Ě","Ë","Í","Ň","Ó","Ö","Ř","Š","Ť","Ú","Ů","Ü","Ý","Ž");
    $nediakritika = array("a","a","c","d","e","e","e","i","n","o","o","r","s","t","u","u","u","y","z","A","A","C","D","E","E","E","I","N","O","O","R","S","T","U","U","U","Y","Z");
    $address = str_replace($diakritika, $nediakritika, $address); 
    $address = strtolower ($address);   
    $address = preg_replace ("/[^[:alpha:][:digit:]]/", "-", $address);  
    $address = trim ($address, "-");  
    $address = preg_replace ("/[-]+/", "-", $address);  
    return($address);  
  }

  public function MapName($id)
  {
    $map_id = Array
    (
      0 => array(0,"Azeroths"),
      1 => array(1,"Kalimdor"),
      13 => array(13,"Test Zone"),
      17 => array(17,"Kalidar"),
      30 => array(30,"Alterac Valley"),
      33 => array(33,"Shadowfang Keep Instance"),
      34 => array(34,"The Stockade Instance"),
      35 => array(35,"Stormwind Prison"),
      36 => array(36,"Deadmines Instance"),
      37 => array(37,"Plains of Snow"),
      43 => array(43,"Wailing Caverns Instance"),
      44 => array(44,"Monastery Interior"),
      47 => array(47,"Razorfen Kraul Instance"),
      48 => array(48,"Blackfathom Deeps Instance"),
      70 => array(70,"Uldaman Instance"),
      90 => array(90,"Gnomeregan Instance"),
      109 => array(109,"Sunken Temple Instance"),
      129 => array(129,"Razorfen Downs Instance"),
      150 => array(150,"Outland"),
      169 => array(169,"Emerald Forest"),
      189 => array(189,"Scarlet Onastery Instance"),
      209 => array(209,"Zul farrak Instance"),
      229 => array(229,"Blackrock Spire Instance"),
      230 => array(230,"Blackrock Depths Instance"),
      249 => array(249,"Onyxia s Lair Instance"),
      269 => array(269,"Cot Black Morass"),
      289 => array(289,"Scholomance Instance"),
      309 => array(309,"Zul Gurub Instance"),
      329 => array(329,"Stratholme Instance"),
      349 => array(349,"Maraudon Instance"),
      369 => array(369,"Deeprun Tram"),
      389 => array(389,"Ragefire Chasm Instance"),
      409 => array(409,"The Molten Core Instance"),
      429 => array(429,"dire_maul Instance"),
      449 => array(449,"Alliance pvp Barracks"),
      450 => array(450,"Horde pvp Barracks"),
      451 => array(451,"Development Land"),
      469 => array(469,"BlackwingLair Instance"),
      489 => array(489,"Warsong Gulch"),
      509 => array(509,"Ruins of ahn Qiraj Instance"),
      529 => array(529,"Arathi Basin"),
      530 => array(530,"Outland"),
      531 => array(531,"Temple of ahn Qiraj Instance"),
      532 => array(532,"Karazahn"),
      533 => array(533,"Naxxramas Instance"),
      534 => array(534,"Cot_hyjal Past"),
      540 => array(540,"Hellfire Military"),
      542 => array(542,"Hellfire Demon"),
      543 => array(543,"Hellfire Rampart"),
      544 => array(544,"Hellfire Raid"),
      545 => array(545,"Coilfang Pumping"),
      546 => array(546,"Coilfang Marsh"),
      547 => array(547,"Coilfang Draenei"),
      548 => array(548,"Coilfang Raid"),
      550 => array(550,"Tempest Keep Raid"),
      552 => array(552,"Tempest Keep Arcane"),
      553 => array(553,"Tempest Keep Atrium"),
      554 => array(554,"Tempest Keep Factory"),
      555 => array(555,"Auchindoun Shadow"),
      556 => array(556,"Auchindoun Srakkoa"),
      557 => array(557,"Auchindoun Ethereal"),
      558 => array(558,"Auchindoun Draenei"),
      559 => array(559,"Nagrand Arena"),
      560 => array(560,"Cot Hillsbrad Past"),
      562 => array(562,"Blades Edge Arena"),
      564 => array(564,"Black Temple"),
      565 => array(565,"Gruuls Lair"),
      566 => array(566,"Netherstorm Arena"),
      568 => array(568,"Zulaman")
    );
    if(isset($map_id[$id])) return($map_id[$id][1]);
    else return("Neznámá");
  }

  public function ZoneName($id)
  {
    $zone_id = Array
    (
      1497 => Array("Undercity",1497),
      1537 => Array("Ironforge",1537),
      1519 => Array("Stormwind city",1519),
      3 => Array("Badlands",3),
      11 => Array("Wetlands",11),
      33 => Array("Stranglethorn Vale",33),
      44 => Array("Redridge Mountains",44),
      38 => Array("Loch Modan",38),
      10 => Array("Duskwood",10),
      41 => Array("Deadwind Pass",41),
      12 => Array("Elwynn Forest",12),
      46 => Array("Burning Steppes",46),
      51 => Array("Searing Gorge",51),
      1 => Array("Dun Morogh",1),
      47 => Array("The Hinterlands",47),
      40 => Array("Westfall",40),
      267 => Array("Hillsbrad Foothills",267),
      139 => Array("Eastern Plaguelands",139),
      28 => Array("Western Plaguelands",28),
      130 => Array("Silverpine Forest",130),
      85 => Array("Tirisfal Glades",85),
      4 => Array("Blasted Lands",4),
      8 => Array("Swamp of Sorrows",8),
      45 => Array("Arathi Highlands",45),
      36 => Array("Alterac Mountains",36),
      1657 => Array("Darnassus",1657),
      1638 => Array("Thunder_bluff",1638),
      1637 => Array("Orgrimmar",1637),
      493 => Array("Moonglade",493),
      1377 => Array("Silithus",1377),
      618 => Array("Winterspring",618),
      490 => Array("Un Goro Crater",490),
      361 => Array("Felwood",361),
      16 => Array("Azshara",16),
      440 => Array("Tanaris",440),
      15 => Array("Dustwallow Marsh",15),
      215 => Array("Mulgore",215),
      357 => Array("Feralas",357),
      405 => Array("Desolace",405),
      400 => Array("Thousand Needles",400),
      14 => Array("Durotar",14),
      331 => Array("Ashenvale",331),
      148 => Array("Darkshore",148),
      141 => Array("Teldrassil",141),
      406 => Array("Stonetalon Mountains",406),
      17 => Array("She Barrens",17),
      3703 => Array("Shattrath city",3703),
      3487 => Array("Silvermoon city",3487),
      3523 => Array("Netherstorm",3523),
      3519 => Array("Terokkar Forest",3519),
      3518 => Array("Nagrand",3518),
      3525 => Array("Bloodmyst Isle",3525),
      3522 => Array("Blades Edge Mountains",3522),
      3520 => Array("Shadowmoon Valley",3520),
      3557 => Array("The Exodar",3557),
      3521 => Array("Zangarmarsh",3521),
      3483 => Array("Hellfire Peninsula",3483),
      3524 => Array("Azuremyst Isle",3524),
      3433 => Array("Ghostlands",3433),
      3430 => Array("Eversong Woods",3430)
    );
    if(isset($zone_id[$id])) return($zone_id[$id][0]);
      else return('-');
  }
  
  function RealmSelection($FormNameSufix = '')
  {
    global $Config;
    
    $Output = '';
    if(count($Config['Mangos']['RealmList']) > 1)
    { 
      $Output .= '<div align="center"><form name="RealmSelection'.$FormNameSufix.'" action="" method="post">'.
      'Svět <select name="RealmIndex" onchange="document.RealmSelection'.$FormNameSufix.'.submit()">';
      foreach($Config['Mangos']['RealmList'] as $Index => $Realm)
      {
        if($_COOKIE['RealmIndex'] == $Index) $Selected = ' selected="selected"';
         else $Selected = '';
        $Output .= '<option value="'.$Index.'"'.$Selected.'>'.$Realm['Name'].'</option>';
      }
      $Output .= '</select>'.
      '</form></div>';
    }
    return($Output);
  }
}

?>
